//---------------------------------------------------------------------------------------------------------------------------------------------------------
//
//
//  HANDHELD CONTROLLER FOR LIVE PERFORMANCE
//  stc@basilar.net, 2011
//  
//
//---------------------------------------------------------------------------------------------------------------------------------------------------------

import apwidgets.*;
import edu.uic.ketai.inputService.*;
import android.content.pm.ActivityInfo;

//  todo : positioning (writtentext,sliders,buttons) / two more recbuf,slider / channels


//---------------------------------------------------------------------------------------------------------------------------------------------------------
// BUTTONS
PWidgetContainer widgetContainer;

//  connect to ip address
PButton button_connect;

//  change pages
PButton button_page1;
PButton button_page2;
PButton button_page3;
PButton button_page4;

//  letting through raw sound
PButton button_raw_sound;

//  record sounds to channels
PButton button_rec_stop_1;
PButton button_rec_stop_2;
PButton button_rec_stop_3;
PButton button_rec_stop_4;
PButton button_rec_stop_5;
PButton button_rec_stop_6;

//  reset button
PButton button_reset;
PButton button_warning;

//  playback mode
PButton button_mode_1_a;
PButton button_mode_1_b;
PButton button_mode_1_c;
PButton button_mode_1_d;
PButton button_mode_2_a;
PButton button_mode_2_b;
PButton button_mode_2_c;
PButton button_mode_2_d;
PButton button_mode_3_a;
PButton button_mode_3_b;
PButton button_mode_3_c;
PButton button_mode_3_d;
PButton button_mode_4_a;
PButton button_mode_4_b;
PButton button_mode_4_c;
PButton button_mode_4_d;
PButton button_mode_5_a;
PButton button_mode_5_b;
PButton button_mode_5_c;
PButton button_mode_5_d;
PButton button_mode_6_a;
PButton button_mode_6_b;
PButton button_mode_6_c;
PButton button_mode_6_d;

//  JELINEK TRACKNUM
int tracknum = 0;

//  INDICATE

int a1, b1, c1, d1, a2, b2, c2, d2, a3, b3, c3, d3, a4, b4, c4, d4, a5, b5, c5, d5, a6, b6, c6, d6, micc = 0;

// SLIDERS
Handle[] handles;
int num;
Handle MASTER;

//  PAGES

int pages = 0;

// OSC
OscP5 oscP5;
// A list to contain the address for sending osc messages 
NetAddressList myAddresses;
KetaiSensorManager sensorManager;
PEditText textField;
String[] fontList;
String address = "192.168.2.103";
PFont androidFont;
int text_size = 32;
Float azimuth, pitch, roll;

//  puska
PImage puska;

//---------------------------------------------------------------------------------------------------------------------------------------------------------

void setup() 
{
  size(screenWidth, screenHeight, A2D);
  orientation(PORTRAIT);
  fontList = PFont.list();
  androidFont = createFont(fontList[0], text_size, true);
  textFont(androidFont);
  
  puska = loadImage("puska.jpg");

  // OSCP5
  oscP5 = new OscP5(this, 12000);
  myAddresses = new NetAddressList();
  myAddresses.add(address, 12000);

  sensorManager = new KetaiSensorManager(this);
  sensorManager.start();

  //  textfield
  
  widgetContainer = new PWidgetContainer(this); //create new container for widgets
  textField = new PEditText(20, 20, 150, 50); //create a textfield from x- and y-pos., width and height
  widgetContainer.addWidget(textField); //place textField in container
  
  //  buttons
  
  button_page1 = new PButton(20,height-100,"PAGE1");
  button_page2 = new PButton(120,height-100,"PAGE2");
  button_page3 = new PButton(220,height-100,"PAGE3");
  button_page4 = new PButton(320,height-100,"PAGE4");
  
  widgetContainer.addWidget(button_page1);
  widgetContainer.addWidget(button_page2);
  widgetContainer.addWidget(button_page3);
  widgetContainer.addWidget(button_page4);
 
  button_connect    = new PButton(180,20,250,50, "ip ok");
  button_reset  = new PButton(250,20,60,50, "[]");
  button_warning  = new PButton(width/2-100,height/2-100,200,200, "WARNING");
  button_raw_sound  = new PButton(320,20,140,50, "MicThru");
   
  button_rec_stop_1 = new PButton(20,160, "R/S_1"); button_mode_1_a = new PButton(120, 160, "Dry"); button_mode_1_b = new PButton(200, 160, "Slow"); button_mode_1_c= new PButton(290, 160, "FX_"); button_mode_1_d= new PButton(370, 160, "<<<");
  button_rec_stop_2 = new PButton(20,260, "R/S_2"); button_mode_2_a = new PButton(120, 260, "Dry"); button_mode_2_b = new PButton(200, 260, "Slow"); button_mode_2_c= new PButton(290, 260, "FX_"); button_mode_2_d= new PButton(370, 260, "<<<");
  button_rec_stop_3 = new PButton(20,360, "R/S_3"); button_mode_3_a = new PButton(120, 360, "Dry"); button_mode_3_b = new PButton(200, 360, "Slow"); button_mode_3_c= new PButton(290, 360, "FX_"); button_mode_3_d= new PButton(370, 360, "<<<");
  button_rec_stop_4 = new PButton(20,460, "R/S_4"); button_mode_4_a = new PButton(120, 460, "Dry"); button_mode_4_b = new PButton(200, 460, "Slow"); button_mode_4_c= new PButton(290, 460, "FX_"); button_mode_4_d= new PButton(370, 460, "<<<");
  button_rec_stop_5 = new PButton(20,560, "R/S_5"); button_mode_5_a = new PButton(120, 560, "Dry"); button_mode_5_b = new PButton(200, 560, "Slow"); button_mode_5_c= new PButton(290, 560, "FX_"); button_mode_5_d= new PButton(370, 560, "<<<");
  button_rec_stop_6 = new PButton(20,660, "R/S_6"); button_mode_6_a = new PButton(120, 660, "Dry"); button_mode_6_b = new PButton(200, 660, "Slow"); button_mode_6_c= new PButton(290, 660, "FX_"); button_mode_6_d= new PButton(370, 660, "<<<");
  
  widgetContainer.addWidget(button_connect);
 
  //  sliders
  num = 8;
  handles = new Handle[num];
  int hsize = 200;
  for(int i=0; i<num; i++) 
  {  
    handles[i] = new Handle(20,120+i*80, hsize, 40, i, handles);
  }
}

//---------------------------------------------------------------------------------------------------------------------------------------------------------

void draw() 
{
  background(0);
  textSize(14);
  
  if(pages == 1)
  {
      //  background bars to indicate min/max + sliders
      stroke(100,198,255);
      strokeWeight(1);
      line(85,70,85,height);
      line(380,70,380,height);
      
      rectMode(CORNERS);
      noStroke();
      fill(100,198,255,55);
      rect(-1,height/2+120,width+1,height);
      
      
      fill(255);
      text("trk: " + tracknum, 10, 40);
      text(textField.getText(), 20, 90); //display the text in the text field
      
      //  slider
      strokeWeight(2);
      stroke(255);
      for(int i=0; i<num; i++) 
      {
        handles[i].update();
        handles[i].display();
      }
  }
  
  //  display
  
  if(pages != 0)
  {
    int s = second();
    int m = minute();  // Values from 0 - 59
    int h = hour();    // Values from 0 - 23
    fill(255);
    text("MIC: " + micc,10,20);
    text(h + " . " + m + " . " + s, 100, 20 );
    if(pages==2)text( a1 + " " + b1 + " " + c1 + " " + d1 + "\n" + a2 + " " + b2 + " " + c2 + " " + d2 + "\n" + a3 + " " + b3 + " " + c3 + " " + d3 + "\n" + a4 + " " + b4 + " " + c4 + " " + d4 + "\n" + a5 + " " + b5 + " " + c5 + " " + d5 + "\n" + a6 + " " + b6 + " " + c6 + " " + d6, 350, 20);
  }
  
  if (pages == 4)
  {
    image(puska,0,40);
  }
}

//---------------------------------------------------------------------------------------------------------------------------------------------------------

void onClickWidget(PWidget widget)
{
  if(widget==button_raw_sound) {if (myAddresses != null) {  oscP5.send("/mic_thru", new Object[] {  new String("pressed")}  , myAddresses.get(0));}micc ++; if(micc>1)micc=0;}
  
  
  if(widget==button_reset) {if (myAddresses != null) {  oscP5.send("/reset", new Object[] {  tracknum + 1  }  , myAddresses.get(0));} tracknum ++; if(tracknum>6)tracknum=0;}
  if(widget==button_warning) {if (myAddresses != null) {  oscP5.send("/warning", new Object[] {  new String("pressed")  }  , myAddresses.get(0));}}
 
  if(widget==button_page1) 
  { 
    pages = 1;
    
    widgetContainer.removeWidget(textField); //remove textField from container
    widgetContainer.removeWidget(button_connect);
    
    widgetContainer.removeWidget(button_warning);
    
    //  remove sample buttons
    
     widgetContainer.removeWidget(button_rec_stop_1);  widgetContainer.removeWidget(button_mode_1_a);  widgetContainer.removeWidget(button_mode_1_b);  widgetContainer.removeWidget(button_mode_1_c);  widgetContainer.removeWidget(button_mode_1_d);
     widgetContainer.removeWidget(button_rec_stop_2);  widgetContainer.removeWidget(button_mode_2_a);  widgetContainer.removeWidget(button_mode_2_b);  widgetContainer.removeWidget(button_mode_2_c);  widgetContainer.removeWidget(button_mode_2_d);
     widgetContainer.removeWidget(button_rec_stop_3);  widgetContainer.removeWidget(button_mode_3_a);  widgetContainer.removeWidget(button_mode_3_b);  widgetContainer.removeWidget(button_mode_3_c);  widgetContainer.removeWidget(button_mode_3_d);
     widgetContainer.removeWidget(button_rec_stop_4);  widgetContainer.removeWidget(button_mode_4_a);  widgetContainer.removeWidget(button_mode_4_b);  widgetContainer.removeWidget(button_mode_4_c);  widgetContainer.removeWidget(button_mode_4_d);
     widgetContainer.removeWidget(button_rec_stop_5);  widgetContainer.removeWidget(button_mode_5_a);  widgetContainer.removeWidget(button_mode_5_b);  widgetContainer.removeWidget(button_mode_5_c);  widgetContainer.removeWidget(button_mode_5_d);
     widgetContainer.removeWidget(button_rec_stop_6);  widgetContainer.removeWidget(button_mode_6_a);  widgetContainer.removeWidget(button_mode_6_b);  widgetContainer.removeWidget(button_mode_6_c);  widgetContainer.removeWidget(button_mode_6_d);
 
    
    //  add optional buttons
    
    widgetContainer.addWidget(button_reset);
    widgetContainer.addWidget(button_raw_sound);
  }
  if(widget==button_page2) 
  { 
    pages = 2;
    
    widgetContainer.removeWidget(textField); //remove textField from container
    widgetContainer.removeWidget(button_connect);
    
    //  remove optional buttons
    
    widgetContainer.removeWidget(button_reset);
    widgetContainer.removeWidget(button_warning);
    widgetContainer.removeWidget(button_raw_sound); 
    
    //  add
    
     widgetContainer.addWidget(button_rec_stop_1);  widgetContainer.addWidget(button_mode_1_a);  widgetContainer.addWidget(button_mode_1_b);  widgetContainer.addWidget(button_mode_1_c);  widgetContainer.addWidget(button_mode_1_d);
     widgetContainer.addWidget(button_rec_stop_2);  widgetContainer.addWidget(button_mode_2_a);  widgetContainer.addWidget(button_mode_2_b);  widgetContainer.addWidget(button_mode_2_c);  widgetContainer.addWidget(button_mode_2_d);
     widgetContainer.addWidget(button_rec_stop_3);  widgetContainer.addWidget(button_mode_3_a);  widgetContainer.addWidget(button_mode_3_b);  widgetContainer.addWidget(button_mode_3_c);  widgetContainer.addWidget(button_mode_3_d);
     widgetContainer.addWidget(button_rec_stop_4);  widgetContainer.addWidget(button_mode_4_a);  widgetContainer.addWidget(button_mode_4_b);  widgetContainer.addWidget(button_mode_4_c);  widgetContainer.addWidget(button_mode_4_d);
     widgetContainer.addWidget(button_rec_stop_5);  widgetContainer.addWidget(button_mode_5_a);  widgetContainer.addWidget(button_mode_5_b);  widgetContainer.addWidget(button_mode_5_c);  widgetContainer.addWidget(button_mode_5_d);
     widgetContainer.addWidget(button_rec_stop_6);  widgetContainer.addWidget(button_mode_6_a);  widgetContainer.addWidget(button_mode_6_b);  widgetContainer.addWidget(button_mode_6_c);  widgetContainer.addWidget(button_mode_6_d); 
  }
  if(widget==button_page3) 
  { 
    pages = 3;
    widgetContainer.removeWidget(textField); //remove textField from container
    widgetContainer.removeWidget(button_connect); 
    
    //  remove optional buttons
    
    widgetContainer.removeWidget(button_reset);
    widgetContainer.removeWidget(button_warning);
    widgetContainer.removeWidget(button_raw_sound); 
    
    
    //  remove sample buttons
    
     widgetContainer.removeWidget(button_rec_stop_1);  widgetContainer.removeWidget(button_mode_1_a);  widgetContainer.removeWidget(button_mode_1_b);  widgetContainer.removeWidget(button_mode_1_c);  widgetContainer.removeWidget(button_mode_1_d);
     widgetContainer.removeWidget(button_rec_stop_2);  widgetContainer.removeWidget(button_mode_2_a);  widgetContainer.removeWidget(button_mode_2_b);  widgetContainer.removeWidget(button_mode_2_c);  widgetContainer.removeWidget(button_mode_2_d);
     widgetContainer.removeWidget(button_rec_stop_3);  widgetContainer.removeWidget(button_mode_3_a);  widgetContainer.removeWidget(button_mode_3_b);  widgetContainer.removeWidget(button_mode_3_c);  widgetContainer.removeWidget(button_mode_3_d);
     widgetContainer.removeWidget(button_rec_stop_4);  widgetContainer.removeWidget(button_mode_4_a);  widgetContainer.removeWidget(button_mode_4_b);  widgetContainer.removeWidget(button_mode_4_c);  widgetContainer.removeWidget(button_mode_4_d);   
     widgetContainer.removeWidget(button_rec_stop_5);  widgetContainer.removeWidget(button_mode_5_a);  widgetContainer.removeWidget(button_mode_5_b);  widgetContainer.removeWidget(button_mode_5_c);  widgetContainer.removeWidget(button_mode_5_d);
     widgetContainer.removeWidget(button_rec_stop_6);  widgetContainer.removeWidget(button_mode_6_a);  widgetContainer.removeWidget(button_mode_6_b);  widgetContainer.removeWidget(button_mode_6_c);  widgetContainer.removeWidget(button_mode_6_d);
 
  
    //  add
    widgetContainer.addWidget(button_warning);

  }
  
  if(widget==button_page4) 
  { 
    pages = 4;
    widgetContainer.removeWidget(textField); //remove textField from container
    widgetContainer.removeWidget(button_connect); 
    
    //  remove optional buttons
    
    widgetContainer.removeWidget(button_reset);
    widgetContainer.removeWidget(button_warning);
    widgetContainer.removeWidget(button_raw_sound); 
    
    
    //  remove sample buttons
    
     widgetContainer.removeWidget(button_rec_stop_1);  widgetContainer.removeWidget(button_mode_1_a);  widgetContainer.removeWidget(button_mode_1_b);  widgetContainer.removeWidget(button_mode_1_c);  widgetContainer.removeWidget(button_mode_1_d);
     widgetContainer.removeWidget(button_rec_stop_2);  widgetContainer.removeWidget(button_mode_2_a);  widgetContainer.removeWidget(button_mode_2_b);  widgetContainer.removeWidget(button_mode_2_c);  widgetContainer.removeWidget(button_mode_2_d);
     widgetContainer.removeWidget(button_rec_stop_3);  widgetContainer.removeWidget(button_mode_3_a);  widgetContainer.removeWidget(button_mode_3_b);  widgetContainer.removeWidget(button_mode_3_c);  widgetContainer.removeWidget(button_mode_3_d);
     widgetContainer.removeWidget(button_rec_stop_4);  widgetContainer.removeWidget(button_mode_4_a);  widgetContainer.removeWidget(button_mode_4_b);  widgetContainer.removeWidget(button_mode_4_c);  widgetContainer.removeWidget(button_mode_4_d);   
     widgetContainer.removeWidget(button_rec_stop_5);  widgetContainer.removeWidget(button_mode_5_a);  widgetContainer.removeWidget(button_mode_5_b);  widgetContainer.removeWidget(button_mode_5_c);  widgetContainer.removeWidget(button_mode_5_d);
     widgetContainer.removeWidget(button_rec_stop_6);  widgetContainer.removeWidget(button_mode_6_a);  widgetContainer.removeWidget(button_mode_6_b);  widgetContainer.removeWidget(button_mode_6_c);  widgetContainer.removeWidget(button_mode_6_d);
 
  }
   
  if(widget==button_rec_stop_1)  {if (myAddresses != null) {  oscP5.send("/rec_stop_1", new Object[]  {  new String("pressed")}  , myAddresses.get(0));}}
  if(widget==button_rec_stop_2)  {if (myAddresses != null) {  oscP5.send("/rec_stop_2", new Object[]  {  new String("pressed")}  , myAddresses.get(0));}}
  if(widget==button_rec_stop_3)  {if (myAddresses != null) {  oscP5.send("/rec_stop_3", new Object[]  {  new String("pressed")}  , myAddresses.get(0));}}
  if(widget==button_rec_stop_4)  {if (myAddresses != null) {  oscP5.send("/rec_stop_4", new Object[]  {  new String("pressed")}  , myAddresses.get(0));}}
  if(widget==button_rec_stop_5)  {if (myAddresses != null) {  oscP5.send("/rec_stop_5", new Object[]  {  new String("pressed")}  , myAddresses.get(0));}}
  if(widget==button_rec_stop_6)  {if (myAddresses != null) {  oscP5.send("/rec_stop_6", new Object[]  {  new String("pressed")}  , myAddresses.get(0));}}
  
  if(widget==button_mode_1_a)  {if (myAddresses != null) {  oscP5.send("/mode_1_a", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} a1 ++; if(a1>1)a1=0;}
  if(widget==button_mode_1_b)  {if (myAddresses != null) {  oscP5.send("/mode_1_b", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} b1 ++; if(b1>1)b1=0;}
  if(widget==button_mode_1_c)  {if (myAddresses != null) {  oscP5.send("/mode_1_c", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} c1 ++; if(c1>1)c1=0;}
  if(widget==button_mode_1_d)  {if (myAddresses != null) {  oscP5.send("/mode_1_d", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} d1 ++; if(d1>1)d1=0;}
  
  if(widget==button_mode_2_a)  {if (myAddresses != null) {  oscP5.send("/mode_2_a", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} a2 ++; if(a2>1)a2=0;}
  if(widget==button_mode_2_b)  {if (myAddresses != null) {  oscP5.send("/mode_2_b", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} b2 ++; if(b2>1)b2=0;}
  if(widget==button_mode_2_c)  {if (myAddresses != null) {  oscP5.send("/mode_2_c", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} c2 ++; if(c2>1)c2=0;}
  if(widget==button_mode_2_d)  {if (myAddresses != null) {  oscP5.send("/mode_2_d", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} d2 ++; if(d2>1)d2=0;}
  
  if(widget==button_mode_3_a)  {if (myAddresses != null) {  oscP5.send("/mode_3_a", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} a3 ++; if(a3>1)a3=0;}
  if(widget==button_mode_3_b)  {if (myAddresses != null) {  oscP5.send("/mode_3_b", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} b3 ++; if(b3>1)b3=0;}
  if(widget==button_mode_3_c)  {if (myAddresses != null) {  oscP5.send("/mode_3_c", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} c3 ++; if(c3>1)c3=0;}
  if(widget==button_mode_3_d)  {if (myAddresses != null) {  oscP5.send("/mode_3_d", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} d3 ++; if(d3>1)d3=0;}
  
  if(widget==button_mode_4_a)  {if (myAddresses != null) {  oscP5.send("/mode_4_a", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} a4 ++; if(a4>1)a4=0;}
  if(widget==button_mode_4_b)  {if (myAddresses != null) {  oscP5.send("/mode_4_b", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} b4 ++; if(b4>1)b4=0;}
  if(widget==button_mode_4_c)  {if (myAddresses != null) {  oscP5.send("/mode_4_c", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} c4 ++; if(c4>1)c4=0;}
  if(widget==button_mode_4_d)  {if (myAddresses != null) {  oscP5.send("/mode_4_d", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} d4 ++; if(d4>1)d4=0;}
  
  if(widget==button_mode_5_a)  {if (myAddresses != null) {  oscP5.send("/mode_5_a", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} a5 ++; if(a5>1)a5=0;}
  if(widget==button_mode_5_b)  {if (myAddresses != null) {  oscP5.send("/mode_5_b", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} b5 ++; if(b5>1)b5=0;}
  if(widget==button_mode_5_c)  {if (myAddresses != null) {  oscP5.send("/mode_5_c", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} c5 ++; if(c5>1)c5=0;}
  if(widget==button_mode_5_d)  {if (myAddresses != null) {  oscP5.send("/mode_5_d", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} d5 ++; if(d5>1)d5=0;}
  
  if(widget==button_mode_6_a)  {if (myAddresses != null) {  oscP5.send("/mode_6_a", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} a6 ++; if(a6>1)a6=0;}
  if(widget==button_mode_6_b)  {if (myAddresses != null) {  oscP5.send("/mode_6_b", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} b6 ++; if(b6>1)b6=0;}
  if(widget==button_mode_6_c)  {if (myAddresses != null) {  oscP5.send("/mode_6_c", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} c6 ++; if(c6>1)c6=0;}
  if(widget==button_mode_6_d)  {if (myAddresses != null) {  oscP5.send("/mode_6_d", new Object[]  {  new String("pressed")}  , myAddresses.get(0));} d6 ++; if(d6>1)d6=0;}
  
  if(widget==button_connect)
  {
    //  set new ip adress for connection
    myAddresses.remove(address, 12000);
    address = textField.getText();
    myAddresses.add(address, 12000);
  }
}

//---------------------------------------------------------------------------------------------------------------------------------------------------------


void mouseReleased() 
{
  for(int i=0; i<num; i++) 
  {
    handles[i].release();
  }
}



