class Handle
{
  int x, y;
  int boxx, boxy;
  int id;
  int length;
  int size;
  boolean over;
  boolean press;
  boolean locked = false;
  boolean otherslocked = false;
  Handle[] others;
  
  Handle(int ix, int iy, int il, int is, int _id, Handle[] o)
  {
    x = ix;
    y = iy;
    id =_id;
    length = il;
    size = is;
    boxx = x+length - size/2;
    boxy = y - size/2;
    others = o;
  }
  
  void update() 
  {
    boxx = x+length;
    boxy = y - size/2;
    
    for(int i=0; i<others.length; i++) 
    {
      if(others[i].locked == true) 
      {
        otherslocked = true;
        break;
      } else 
      {
        otherslocked = false;
      }  
    }
    
    if(otherslocked == false) 
    {
      over();
      press();
    }
    
    if(press) 
    {
      length = lock(mouseX - size/2, 0, width-size-1);
    }
  }
  
  void over()
  {
    if(overRect(boxx, boxy, size, size)) 
    {
      over = true;
    } 
    else 
    {
      over = false;
    }
  }
  
  void press()
  {
    if(over && mousePressed || locked) 
    {
      press = true;
      locked = true;
    } 
    else 
    {
      press = false;
    }
  }
  
  void release()
  {
    locked = false;
  }
  
  void display() 
  {
    line(x, y, x+length, y);
    fill(88);
    ellipse(boxx+size/2, boxy+size/2, size, size);
    
    if(over || press) 
    {
      line(boxx+10, boxy+10, boxx+size-10, boxy+size-10);
      line(boxx+10, boxy+size-10, boxx+size-10, boxy+10);
      text("slider num: " + id + " slider value: " + length, 20, height-20);
      
      if (myAddresses != null) 
      {
        oscP5.send("/slider", new Object[] 
        {
          new Float(id), new Float(length)
        }
      , myAddresses.get(0));
      }
    }
  }
}

boolean overRect(int x, int y, int width, int height) 
{
  if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height) 
      {
    return true;
  } 
  else 
  {
    return false;
  }
}

int lock(int val, int minv, int maxv) 
{ 
  return  min(max(val, minv), maxv); 
}


